
# line 32 "ftpcmd.y"

#include "config.h"
#include <sys/param.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/stat.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include "../support/ftp.h"
#include <stdio.h>
#include <signal.h>
#include <errno.h>
#include <ctype.h>
#include <pwd.h>
#include <setjmp.h>
#ifdef HAVE_SYS_SYSLOG_H
#include <sys/syslog.h>
#endif
#if defined(HAVE_SYSLOG_H) || (!defined(AUTOCONF) && !defined(HAVE_SYS_SYSLOG_H))
#include <syslog.h>
#endif
#include <time.h>
#include <stdlib.h>
#include <string.h>
#include <limits.h>
#include "extensions.h"
#include "pathnames.h"
#include "proto.h"

extern int dolreplies;
#ifndef INTERNAL_LS
extern char ls_long[50];
extern char ls_short[50];
#endif
extern struct sockaddr_in data_dest;
extern struct sockaddr_in his_addr;	/* added.  _H */
extern int logged_in;
extern struct passwd *pw;
extern int anonymous;
extern int logging;
extern int log_commands;
extern int log_security;
extern int type;
extern int form;
extern int debug;
extern unsigned int timeout_idle;
extern unsigned int timeout_maxidle;
extern int pdata;
extern char hostname[], remotehost[], *remoteident;
extern char remoteaddr[];
extern char chroot_path[];
extern char guestpw[], authuser[];	/* added.  _H */
extern char proctitle[];
extern char *globerr;
extern int usedefault;
extern int transflag;
extern char tmpline[];
extern int data;
extern int errno;
extern char *home;

off_t restart_point;
int yyerrorcalled;

extern char *strunames[];
extern char *typenames[];
extern char *modenames[];
extern char *formnames[];
extern int restricted_user;	/* global flag indicating if user is restricted to home directory */

#ifdef TRANSFER_COUNT
extern int data_count_total;
extern int data_count_in;
extern int data_count_out;
extern int byte_count_total;
extern int byte_count_in;
extern int byte_count_out;
extern int file_count_total;
extern int file_count_in;
extern int file_count_out;
extern int xfer_count_total;
extern int xfer_count_in;
extern int xfer_count_out;
#endif

extern int retrieve_is_data;

#ifdef VIRTUAL
extern int virtual_mode;
extern int virtual_ftpaccess;
extern char virtual_email[];
#endif

#ifdef IGNORE_NOOP
static int alarm_running = 0;
#endif

static unsigned short cliport = 0;
static struct in_addr cliaddr;
static int cmd_type;
static int cmd_form;
static int cmd_bytesz;
char cbuf[512];
char *fromname;

/* Debian linux bison fix: moved this up, added forward decls */

struct tab {
    char *name;
    short token;
    short state;
    short implemented;		/* 1 if command is implemented */
    char *help;
};

extern struct tab cmdtab[];
extern struct tab sitetab[];

static void toolong(int);
void help(struct tab *ctab, char *s);
struct tab *lookup(register struct tab *p, char *cmd);
int yylex(void);

static char *nullstr = "(null)";
#define CHECKNULL(p) ((p) ? (p) : nullstr)

extern int pasv_allowed(const char *remoteaddr);
extern int port_allowed(const char *remoteaddr);

# line 182 "ftpcmd.y"
typedef union  {
    char *String;
    int Number;
} YYSTYPE;
# define A 257
# define B 258
# define C 259
# define E 260
# define F 261
# define I 262
# define L 263
# define N 264
# define P 265
# define R 266
# define S 267
# define T 268
# define SP 269
# define CRLF 270
# define COMMA 271
# define STRING 272
# define NUMBER 273
# define USER 274
# define PASS 275
# define ACCT 276
# define REIN 277
# define QUIT 278
# define PORT 279
# define PASV 280
# define TYPE 281
# define STRU 282
# define MODE 283
# define RETR 284
# define STOR 285
# define APPE 286
# define MLFL 287
# define MAIL 288
# define MSND 289
# define MSOM 290
# define MSAM 291
# define MRSQ 292
# define MRCP 293
# define ALLO 294
# define REST 295
# define RNFR 296
# define RNTO 297
# define ABOR 298
# define DELE 299
# define CWD 300
# define LIST 301
# define NLST 302
# define SITE 303
# define STAT 304
# define HELP 305
# define NOOP 306
# define MKD 307
# define RMD 308
# define PWD 309
# define CDUP 310
# define STOU 311
# define SMNT 312
# define SYST 313
# define SIZE 314
# define MDTM 315
# define UMASK 316
# define IDLE 317
# define CHMOD 318
# define GROUP 319
# define GPASS 320
# define NEWER 321
# define MINFO 322
# define INDEX 323
# define EXEC 324
# define ALIAS 325
# define CDPATH 326
# define GROUPS 327
# define CHECKMETHOD 328
# define CHECKSUM 329
# define LEXERR 330
#define yyclearin yychar = -1
#define yyerrok yyerrflag = 0
extern int yychar;
extern short yyerrflag;
#ifndef YYMAXDEPTH
#define YYMAXDEPTH 150
#endif
YYSTYPE yylval, yyval;
# define YYERRCODE 256

# line 1234 "ftpcmd.y"


extern jmp_buf errcatch;

#define CMD 0			/* beginning of command */
#define ARGS    1		/* expect miscellaneous arguments */
#define STR1    2		/* expect SP followed by STRING */
#define STR2    3		/* expect STRING */
#define OSTR    4		/* optional SP then STRING */
#define ZSTR1   5		/* SP then optional STRING */
#define ZSTR2   6		/* optional STRING after SP */
#define SITECMD 7		/* SITE command */
#define NSTR    8		/* Number followed by a string */
#define STR3    9		/* expect STRING followed by optional SP then STRING */

struct tab cmdtab[] =
{				/* In order defined in RFC 765 */
    {"USER", USER, STR1, 1, "<sp> username"},
    {"PASS", PASS, ZSTR1, 1, "<sp> password"},
    {"ACCT", ACCT, STR1, 0, "(specify account)"},
    {"SMNT", SMNT, ARGS, 0, "(structure mount)"},
    {"REIN", REIN, ARGS, 0, "(reinitialize server state)"},
    {"QUIT", QUIT, ARGS, 1, "(terminate service)",},
    {"PORT", PORT, ARGS, 1, "<sp> b0, b1, b2, b3, b4, b5"},
    {"PASV", PASV, ARGS, 1, "(set server in passive mode)"},
    {"TYPE", TYPE, ARGS, 1, "<sp> [ A | E | I | L ]"},
    {"STRU", STRU, ARGS, 1, "(specify file structure)"},
    {"MODE", MODE, ARGS, 1, "(specify transfer mode)"},
    {"RETR", RETR, STR1, 1, "<sp> file-name"},
    {"STOR", STOR, STR1, 1, "<sp> file-name"},
    {"APPE", APPE, STR1, 1, "<sp> file-name"},
    {"MLFL", MLFL, OSTR, 0, "(mail file)"},
    {"MAIL", MAIL, OSTR, 0, "(mail to user)"},
    {"MSND", MSND, OSTR, 0, "(mail send to terminal)"},
    {"MSOM", MSOM, OSTR, 0, "(mail send to terminal or mailbox)"},
    {"MSAM", MSAM, OSTR, 0, "(mail send to terminal and mailbox)"},
    {"MRSQ", MRSQ, OSTR, 0, "(mail recipient scheme question)"},
    {"MRCP", MRCP, STR1, 0, "(mail recipient)"},
    {"ALLO", ALLO, ARGS, 1, "allocate storage (vacuously)"},
    {"REST", REST, ARGS, 1, "(restart command)"},
    {"RNFR", RNFR, STR1, 1, "<sp> file-name"},
    {"RNTO", RNTO, STR1, 1, "<sp> file-name"},
    {"ABOR", ABOR, ARGS, 1, "(abort operation)"},
    {"DELE", DELE, STR1, 1, "<sp> file-name"},
    {"CWD", CWD, OSTR, 1, "[ <sp> directory-name ]"},
    {"XCWD", CWD, OSTR, 1, "[ <sp> directory-name ]"},
    {"LIST", LIST, OSTR, 1, "[ <sp> path-name ]"},
    {"NLST", NLST, OSTR, 1, "[ <sp> path-name ]"},
    {"SITE", SITE, SITECMD, 1, "site-cmd [ <sp> arguments ]"},
    {"SYST", SYST, ARGS, 1, "(get type of operating system)"},
    {"STAT", STAT, OSTR, 1, "[ <sp> path-name ]"},
    {"HELP", HELP, OSTR, 1, "[ <sp> <string> ]"},
    {"NOOP", NOOP, ARGS, 1, ""},
    {"MKD", MKD, STR1, 1, "<sp> path-name"},
    {"XMKD", MKD, STR1, 1, "<sp> path-name"},
    {"RMD", RMD, STR1, 1, "<sp> path-name"},
    {"XRMD", RMD, STR1, 1, "<sp> path-name"},
    {"PWD", PWD, ARGS, 1, "(return current directory)"},
    {"XPWD", PWD, ARGS, 1, "(return current directory)"},
    {"CDUP", CDUP, ARGS, 1, "(change to parent directory)"},
    {"XCUP", CDUP, ARGS, 1, "(change to parent directory)"},
    {"STOU", STOU, STR1, 1, "<sp> file-name"},
    {"SIZE", SIZE, OSTR, 1, "<sp> path-name"},
    {"MDTM", MDTM, OSTR, 1, "<sp> path-name"},
    {NULL, 0, 0, 0, 0}
};

struct tab sitetab[] =
{
    {"UMASK", UMASK, ARGS, 1, "[ <sp> umask ]"},
    {"IDLE", IDLE, ARGS, 1, "[ <sp> maximum-idle-time ]"},
    {"CHMOD", CHMOD, NSTR, 1, "<sp> mode <sp> file-name"},
    {"HELP", HELP, OSTR, 1, "[ <sp> <string> ]"},
    {"GROUP", GROUP, STR1, 1, "<sp> access-group"},
    {"GPASS", GPASS, OSTR, 1, "<sp> access-password"},
    {"NEWER", NEWER, STR3, 1, "<sp> YYYYMMDDHHMMSS [ <sp> path-name ]"},
    {"MINFO", MINFO, STR3, 1, "<sp> YYYYMMDDHHMMSS [ <sp> path-name ]"},
    {"INDEX", INDEX, STR1, 1, "<sp> pattern"},
    {"EXEC", EXEC, STR1, 1, "<sp> command [ <sp> arguments ]"},
    {"ALIAS", ALIAS, OSTR, 1, "[ <sp> alias ] "},
    {"CDPATH", CDPATH, OSTR, 1, "[ <sp> ] "},
    {"GROUPS", GROUPS, OSTR, 1, "[ <sp> ] "},
    {"CHECKMETHOD", CHECKMETHOD, OSTR, 1, "[ <sp> method ]"},
    {"CHECKSUM", CHECKSUM, OSTR, 1, "[ <sp> file-name ]"},
    {NULL, 0, 0, 0, 0}
};

struct tab *lookup(register struct tab *p, char *cmd)
{
    for (; p->name != NULL; p++)
	if (strcmp(cmd, p->name) == 0)
	    return (p);
    return (0);
}

#include <arpa/telnet.h>

/*
 * getline - a hacked up version of fgets to ignore TELNET escape codes.
 */
char *wu_getline(char *s, int n, register FILE *iop)
{
    register int c;
    register char *cs;
    char *passtxt = "PASS password\r\n";

    cs = s;
/* tmpline may contain saved command from urgent mode interruption */
    for (c = 0; tmpline[c] != '\0' && --n > 0; ++c) {
	*cs++ = tmpline[c];
	if (tmpline[c] == '\n') {
	    *cs++ = '\0';
	    if (debug) {
		if (strncasecmp(passtxt, s, 5) == 0)
		    syslog(LOG_DEBUG, "command: %s", passtxt);
		else
		    syslog(LOG_DEBUG, "command: %s", s);
	    }
	    tmpline[0] = '\0';
	    return (s);
	}
	if (c == 0)
	    tmpline[0] = '\0';
    }
  retry:
    while ((c = getc(iop)) != EOF) {
#ifdef TRANSFER_COUNT
	byte_count_total++;
	byte_count_in++;
#endif
	c &= 0377;
	if (c == IAC) {
	    if ((c = getc(iop)) != EOF) {
#ifdef TRANSFER_COUNT
		byte_count_total++;
		byte_count_in++;
#endif
		c &= 0377;
		switch (c) {
		case WILL:
		case WONT:
		    c = getc(iop);
#ifdef TRANSFER_COUNT
		    byte_count_total++;
		    byte_count_in++;
#endif
		    printf("%c%c%c", IAC, DONT, 0377 & c);
		    (void) fflush(stdout);
		    continue;
		case DO:
		case DONT:
		    c = getc(iop);
#ifdef TRANSFER_COUNT
		    byte_count_total++;
		    byte_count_in++;
#endif
		    printf("%c%c%c", IAC, WONT, 0377 & c);
		    (void) fflush(stdout);
		    continue;
		case IAC:
		    break;
		default:
		    continue;	/* ignore command */
		}
	    }
	}
	*cs++ = c;
	if (--n <= 0 || c == '\n')
	    break;
    }

    if (c == EOF && cs == s) {
	if (ferror(iop) && (errno == EINTR))
	    goto retry;
	return (NULL);
    }

    *cs++ = '\0';
    if (debug) {
	if (strncasecmp(passtxt, s, 5) == 0)
	    syslog(LOG_DEBUG, "command: %s", passtxt);
	else
	    syslog(LOG_DEBUG, "command: %s", s);
    }
    return (s);
}

static void toolong(int a) /* signal that caused this function to be called */
{
    time_t now;

    reply(421,
	  "Timeout (%d seconds): closing control connection.", timeout_idle);
    (void) time(&now);
    if (logging) {
	syslog(LOG_INFO,
	       "User %s timed out after %d seconds at %.24s",
	       (pw ? pw->pw_name : "unknown"), timeout_idle, ctime(&now));
    }
    dologout(1);
}

int yylex(void)
{
    static int cpos, state;
    register char *cp, *cp2;
    register struct tab *p;
    int n;
    time_t now;
    char c = '\0';
    extern time_t limit_time;
    extern time_t login_time;

    for (;;) {
	switch (state) {

	case CMD:
	    yyerrorcalled = 0;

	    setproctitle("%s: IDLE", proctitle);

	    if (is_shutdown(!logged_in, 0) != 0) {
		reply(221, "Server shutting down.  Goodbye.");
		dologout(0);
	    }

	    time(&now);
	    if ((limit_time > 0) && (((now - login_time) / 60) > limit_time)) {
		reply(221, "Time limit reached.  Goodbye.");
		dologout(0);
	    }

#ifdef IGNORE_NOOP
	    if (!alarm_running) {
		(void) signal(SIGALRM, toolong);
		(void) alarm((unsigned) timeout_idle);
		alarm_running = 1;
	    }
#else
	    (void) signal(SIGALRM, toolong);
	    (void) alarm((unsigned) timeout_idle);
#endif
	    if (wu_getline(cbuf, sizeof(cbuf) - 1, stdin) == NULL) {
		(void) alarm(0);
		reply(221, "You could at least say goodbye.");
		dologout(0);
	    }
#ifndef IGNORE_NOOP
	    (void) alarm(0);
#endif
	    if ((cp = strchr(cbuf, '\r'))) {
		*cp++ = '\n';
		*cp = '\0';
	    }
	    if ((cp = strpbrk(cbuf, " \n")))
		cpos = cp - cbuf;
	    if (cpos == 0)
		cpos = 4;
	    c = cbuf[cpos];
	    cbuf[cpos] = '\0';
	    upper(cbuf);
#ifdef IGNORE_NOOP
	    if (strncasecmp(cbuf, "NOOP", 4) != 0) {
		(void) alarm(0);
		alarm_running = 0;
	    }
#endif
	    p = lookup(cmdtab, cbuf);
	    cbuf[cpos] = c;
	    if (strncasecmp(cbuf, "PASS", 4) != 0 &&
		strncasecmp(cbuf, "SITE GPASS", 10) != 0) {
		if ((cp = strchr(cbuf, '\n')))
		    *cp = '\0';
		setproctitle("%s: %s", proctitle, cbuf);
		if (cp)
		    *cp = '\n';
	    }
	    if (p != 0) {
		if (p->implemented == 0) {
		    nack(p->name);
		    longjmp(errcatch, 0);
		    /* NOTREACHED */
		}
		state = p->state;
		yylval.String = p->name;
		return (p->token);
	    }
	    break;

	case SITECMD:
	    if (cbuf[cpos] == ' ') {
		cpos++;
		return (SP);
	    }
	    cp = &cbuf[cpos];
	    if ((cp2 = strpbrk(cp, " \n")))
		cpos = cp2 - cbuf;
	    c = cbuf[cpos];
	    cbuf[cpos] = '\0';
	    upper(cp);
	    p = lookup(sitetab, cp);
	    cbuf[cpos] = c;
	    if (p != 0) {
#ifndef PARANOID		/* what GOOD is SITE *, anyways?!  _H */
		if (p->implemented == 0) {
#else
		if (1) {
		    syslog(LOG_WARNING, "refused SITE %s %s from %s of %s",
			   p->name, &cbuf[cpos],
			   anonymous ? guestpw : authuser, remoteident);
#endif /* PARANOID */
		    state = CMD;
		    nack(p->name);
		    longjmp(errcatch, 0);
		    /* NOTREACHED */
		}
		state = p->state;
		yylval.String = p->name;
		return (p->token);
	    }
	    state = CMD;
	    break;

	case OSTR:
	    if (cbuf[cpos] == '\n') {
		state = CMD;
		return (CRLF);
	    }
	    /* FALLTHROUGH */

	case STR1:
	case ZSTR1:
	  dostr1:
	    if (cbuf[cpos] == ' ') {
		cpos++;
		if (state == OSTR)
		    state = STR2;
		else
		    ++state;
		return (SP);
	    }
	    break;

	case ZSTR2:
	    if (cbuf[cpos] == '\n') {
		state = CMD;
		return (CRLF);
	    }
	    /* FALLTHROUGH */

	case STR2:
	    cp = &cbuf[cpos];
	    n = strlen(cp);
	    cpos += n - 1;
	    /*
	     * Make sure the string is nonempty and \n terminated.
	     */
	    if (n > 1 && cbuf[cpos] == '\n') {
		cbuf[cpos] = '\0';
		yylval.String = copy(cp);
		cbuf[cpos] = '\n';
		state = ARGS;
		return (STRING);
	    }
	    break;

	case NSTR:
	    if (cbuf[cpos] == ' ') {
		cpos++;
		return (SP);
	    }
	    if (isdigit(cbuf[cpos])) {
		cp = &cbuf[cpos];
		while (isdigit(cbuf[++cpos]));
		c = cbuf[cpos];
		cbuf[cpos] = '\0';
		yylval.Number = atoi(cp);
		cbuf[cpos] = c;
		state = STR1;
		return (NUMBER);
	    }
	    state = STR1;
	    goto dostr1;

	case STR3:
	    if (cbuf[cpos] == ' ') {
		cpos++;
		return (SP);
	    }

	    cp = &cbuf[cpos];
	    cp2 = strpbrk(cp, " \n");
	    if (cp2 != NULL) {
		c = *cp2;
		*cp2 = '\0';
	    }
	    n = strlen(cp);
	    cpos += n;
	    /*
	     * Make sure the string is nonempty and SP terminated.
	     */
	    if ((cp2 - cp) > 1) {
		yylval.String = copy(cp);
		cbuf[cpos] = c;
		state = OSTR;
		return (STRING);
	    }
	    break;

	case ARGS:
	    if (isdigit(cbuf[cpos])) {
		cp = &cbuf[cpos];
		while (isdigit(cbuf[++cpos]));
		c = cbuf[cpos];
		cbuf[cpos] = '\0';
		yylval.Number = atoi(cp);
		cbuf[cpos] = c;
		return (NUMBER);
	    }
	    switch (cbuf[cpos++]) {

	    case '\n':
		state = CMD;
		return (CRLF);

	    case ' ':
		return (SP);

	    case ',':
		return (COMMA);

	    case 'A':
	    case 'a':
		return (A);

	    case 'B':
	    case 'b':
		return (B);

	    case 'C':
	    case 'c':
		return (C);

	    case 'E':
	    case 'e':
		return (E);

	    case 'F':
	    case 'f':
		return (F);

	    case 'I':
	    case 'i':
		return (I);

	    case 'L':
	    case 'l':
		return (L);

	    case 'N':
	    case 'n':
		return (N);

	    case 'P':
	    case 'p':
		return (P);

	    case 'R':
	    case 'r':
		return (R);

	    case 'S':
	    case 's':
		return (S);

	    case 'T':
	    case 't':
		return (T);

	    }
	    break;

	default:
	    fatal("Unknown state in scanner.");
	}
	if (yyerrorcalled == 0) {
	    if ((cp = strchr(cbuf, '\n')) != NULL)
		*cp = '\0';
	    if (logged_in)
		reply(500, "'%s': command not understood.", cbuf);
	    else
		reply(530, "Please login with USER and PASS.");
	}
	state = CMD;
	longjmp(errcatch, 0);
    }
}

void upper(char *s)
{
    while (*s != '\0') {
	if (islower(*s))
	    *s = toupper(*s);
	s++;
    }
}

char *copy(char *s)
{
    char *p;

    p = (char *) malloc((unsigned) strlen(s) + 1);
    if (p == NULL)
	fatal("Ran out of memory.");
    (void) strcpy(p, s);
    return (p);
}

void help(struct tab *ctab, char *s)
{
    struct aclmember *entry = NULL;
    struct tab *c;
    size_t width, NCMDS;
    char *type;

    if (ctab == sitetab)
	type = "SITE ";
    else
	type = "";
    width = 0, NCMDS = 0;
    for (c = ctab; c->name != NULL; c++) {
	size_t len = strlen(c->name);

	if (len > width)
	    width = len;
	NCMDS++;
    }
    width = (width + 8) & ~7;
    if (s == 0) {
	register size_t i, j, w;
	size_t columns, lines;

	lreply(214, "The following %scommands are recognized %s.",
	       type, "(* =>'s unimplemented)");
	columns = 76 / width;
	if (columns == 0)
	    columns = 1;
	lines = (NCMDS + columns - 1) / columns;
	for (i = 0; i < lines; i++) {
	    char line[BUFSIZ], *ptr = line;
	    strcpy(ptr, "   ");
	    ptr += 3;
	    for (j = 0; j < columns; j++) {
		c = ctab + j * lines + i;
		(void) sprintf(ptr, "%s%c", c->name,
			       c->implemented ? ' ' : '*');
		w = strlen(c->name) + 1;
		ptr += w;
		if (c + lines >= &ctab[NCMDS])
		    break;
		while (w < width) {
		    *(ptr++) = ' ';
		    w++;
		}
	    }
	    *ptr = '\0';
	    lreply(0, "%s", line);
	}
	(void) fflush(stdout);
#ifdef VIRTUAL
	if (virtual_mode && !virtual_ftpaccess && virtual_email[0] != '\0')
	    reply(214, "Direct comments to %s.", virtual_email);
	else
#endif
	if ((getaclentry("email", &entry)) && ARG0)
	    reply(214, "Direct comments to %s.", ARG0);
	else
	    reply(214, "Direct comments to ftp-bugs@%s.", hostname);
	return;
    }
    upper(s);
    c = lookup(ctab, s);
    if (c == (struct tab *) NULL) {
	reply(502, "Unknown command %s.", s);
	return;
    }
    if (c->implemented)
	reply(214, "Syntax: %s%s %s", type, c->name, c->help);
    else
	reply(214, "%s%-*s\t%s; unimplemented.", type, width,
	      c->name, c->help);
}

void sizecmd(char *filename)
{
    switch (type) {
    case TYPE_L:
    case TYPE_I:{
	    struct stat stbuf;
	    if (stat(filename, &stbuf) < 0 ||
		(stbuf.st_mode & S_IFMT) != S_IFREG)
		reply(550, "%s: not a plain file.", filename);
	    else
#if OFFSET_SIZE == 8
		reply(213, "%qu", stbuf.st_size);
#else
#ifdef _AIX42
		reply(213, "%llu", stbuf.st_size);
#else
		reply(213, "%lu", stbuf.st_size);
#endif
#endif
	    break;
	}
    case TYPE_A:{
	    FILE *fin;
	    register int c;
	    register long count;
	    struct stat stbuf;
	    fin = fopen(filename, "r");
	    if (fin == NULL) {
		perror_reply(550, filename);
		return;
	    }
	    if (fstat(fileno(fin), &stbuf) < 0 ||
		(stbuf.st_mode & S_IFMT) != S_IFREG) {
		reply(550, "%s: not a plain file.", filename);
		(void) fclose(fin);
		return;
	    }

	    count = 0;
	    while ((c = getc(fin)) != EOF) {
		if (c == '\n')	/* will get expanded to \r\n */
		    count++;
		count++;
	    }
	    (void) fclose(fin);

	    reply(213, "%ld", count);
	    break;
	}
    default:
	reply(504, "SIZE not implemented for Type %c.", "?AEIL"[type]);
    }
}

void site_exec(char *cmd)
{
#ifdef PARANOID
    syslog(LOG_CRIT, "REFUSED SITE_EXEC (slipped through!!): %s", cmd);
#else
    char buf[MAXPATHLEN];
    char *sp = (char *) strchr(cmd, ' '), *slash, *t;
    FILE *cmdf;


    /* sanitize the command-string */

    if (sp == 0) {
	while ((slash = strchr(cmd, '/')) != 0)
	    cmd = slash + 1;
    }
    else {
	while (sp && (slash = (char *) strchr(cmd, '/'))
	       && (slash < sp))
	    cmd = slash + 1;
    }

    for (t = cmd; *t && !isspace(*t); t++) {
	if (isupper(*t)) {
	    *t = tolower(*t);
	}
    }

    /* build the command */
    if (strlen(_PATH_EXECPATH) + strlen(cmd) + 2 > sizeof(buf))
	return;
    sprintf(buf, "%s/%s", _PATH_EXECPATH, cmd);

    cmdf = ftpd_popen(buf, "r", 0);
    if (!cmdf) {
	perror_reply(550, cmd);
	if (log_commands)
	    syslog(LOG_INFO, "SITE EXEC (FAIL: %m): %s", cmd);
    }
    else {
	int lines = 0;
	int maxlines = 0;
	struct aclmember *entry = NULL;
	char class[1024];
	int maxfound = 0;
	int defmaxlines = 20;
	int which;

	(void) acl_getclass(class);
	while ((getaclentry("site-exec-max-lines", &entry)) && ARG0) {
	    if (ARG1)
		for (which = 1; (which < MAXARGS) && ARG[which]; which++) {
		    if (!strcasecmp(ARG[which], class)) {
			maxlines = atoi(ARG0);
			maxfound = 1;
		    }
		    if (!strcmp(ARG[which], "*"))
			defmaxlines = atoi(ARG0);
		}
	    else
		defmaxlines = atoi(ARG0);
	}
	if (!maxfound)
	    maxlines = defmaxlines;
	lreply(200, "%s", cmd);
	while (fgets(buf, sizeof buf, cmdf)) {
	    size_t len = strlen(buf);

	    if (len > 0 && buf[len - 1] == '\n')
		buf[--len] = '\0';
	    lreply(200, "%s", buf);
	    if (maxlines <= 0)
		++lines;
	    else if (++lines >= maxlines) {
		lreply(200, "*** Truncated ***");
		break;
	    }
	}
	reply(200, " (end of '%s')", cmd);
	if (log_commands)
	    syslog(LOG_INFO, "SITE EXEC (lines: %d): %s", lines, cmd);
	ftpd_pclose(cmdf);
    }
#endif /* PARANOID */
}

void alias(char *s)
{
    struct aclmember *entry = NULL;

    if (s != (char *) NULL) {
	while (getaclentry("alias", &entry) && ARG0 && ARG1 != NULL)
	    if (!strcmp(ARG0, s)) {
		reply(214, "%s is an alias for %s.", ARG0, ARG1);
		return;
	    }
	reply(502, "Unknown alias %s.", s);
	return;
    }

    lreply(214, "The following aliases are available.");

    while (getaclentry("alias", &entry) && ARG0 && ARG1 != NULL)
	lreply(0, "   %-8s %s", ARG0, ARG1);
    (void) fflush(stdout);

    reply(214, "");
}

void cdpath(void)
{
    struct aclmember *entry = NULL;

    lreply(214, "The cdpath is:");
    while (getaclentry("cdpath", &entry) && ARG0 != NULL)
	lreply(0, "  %s", ARG0);
    (void) fflush(stdout);
    reply(214, "");
}

void print_groups(void)
{
    gid_t groups[NGROUPS_MAX];
    int ngroups = 0;

    if ((ngroups = getgroups(NGROUPS_MAX, groups)) < 0) {
	return;
    }

    lreply(214, "Group membership is:");
    ngroups--;

    for (; ngroups >= 0; ngroups--)
	lreply(214, "  %d", groups[ngroups]);

    (void) fflush(stdout);
    reply(214, "");
}
short yyexca[] ={
-1, 1,
	0, -1,
	-2, 0,
	};
# define YYNPROD 93
# define YYLAST 390
short yyact[]={

  34, 166, 265, 263, 261, 160, 252, 251, 223, 221,
 160, 211, 125, 111, 128, 232, 260, 230,   4,   5,
 229, 228,  33,   6,   7,   8,   9,  10,  12,  13,
  14, 227, 226,  73,  71, 219, 137, 131,  11,  36,
  35,  19,  20,  18,  21,  16,  15,  28,  17,  22,
  23,  24,  25,  26,  27,  29, 140,  30,  31,  32,
 264, 262, 256, 245, 244, 243, 242, 141, 143, 142,
 144, 145, 146, 147, 148, 149, 150, 152, 151, 153,
 154, 234, 204, 205, 202, 203, 199, 198, 192, 193,
 190, 189, 187, 186, 185, 184, 171, 170, 238, 162,
  95,  94,  93,  92,  87,  88,  86,  85,  84,  83,
 259, 258, 257, 250, 249, 248, 247, 246, 241, 240,
 239, 237, 236, 215, 210, 209, 208, 207, 213, 206,
 201, 200, 214, 183, 126, 182, 181, 180, 179, 178,
 177, 176, 175, 174, 173, 172, 169, 168, 163, 161,
 109, 108, 103, 100,  99,  96,  91,  75,  67,  66,
 235, 197, 196, 195, 194, 191, 188, 165, 164, 123,
 124, 107, 106, 105, 104, 102, 101,  98, 122,  97,
  70,  90,  89,  82,  81,  80,  79,  78,  77,  76,
  74,  38,  37, 118, 218,  72, 113, 120, 119, 114,
 220, 115, 116, 159, 112, 212, 110,   3,   2,   1,
 121, 117, 231, 127,   0,   0, 129, 130,   0,   0,
   0, 132, 133,   0, 134, 135,   0,   0, 136,   0,
   0,   0, 138, 139,  39,   0,   0, 155,   0, 156,
 157, 158,  40,  41,  42,  43,  44,  45,  46,  47,
  48,  49,  50,  51,  52,  53,  54,  55,  56,  57,
  58,  59,  60,  61,  62,  63,  64,  65,   0,   0,
  68,  69,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
 167,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0, 233,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
 217, 216, 224, 253,   0,   0,   0,   0, 254,   0,
 255,   0,   0,   0,   0,   0,   0,   0, 225, 222 };
short yypact[]={

-1000,-256,-1000,-1000, -77, -78,-1000,-1000,-1000,-1000,
-1000,-1000,-1000,-1000,-1000,-1000,-1000,-1000,-1000,-1000,
-1000,-1000,-1000,-1000,-1000,-1000,-1000,-1000,-1000,-1000,
-1000,-1000,-1000,-111,-112,-1000,-1000,-238,-239, -79,
-113, -80, -81, -82, -83, -84, -85, -86,-161,-163,
-165, -87, -88,-114,-167,-169,-115, -90, -92,-116,
-117, -93, -94,-118, -95, -96,-1000,-1000, -97, -98,
-119,-1000,-120,-1000,-260,-1000, -61, -68, -89,-261,
-258,-258,-258,-1000,-235,-1000,-258,-258,-1000,-258,
-258,-1000,-1000,-258,-1000,-236,-1000,-258,-258,-1000,
-1000,-249,-258,-1000,-258,-258,-258,-263,-1000,-1000,
-121,-172,-122,-101,-102,-1000,-268,-123,-1000,-1000,
-1000,-124,-1000,-1000,-1000,-173,-125,-1000,-1000,-126,
-127,-128,-129,-130,-131,-132,-133,-134,-135,-137,
-175,-177,-103,-179,-104,-181,-105,-106,-107,-108,
-183,-139,-140,-185,-187,-141,-143,-144,-145,-146,
-1000,-1000,-262,-1000,-136,-136,-263,-1000,-1000,-1000,
-1000, -72,-1000,-1000,-1000,-1000,-1000,-1000,-1000,-1000,
-1000,-1000,-1000,-1000,-1000,-237,-1000,-264,-264,-1000,
-265,-238,-239,-1000,-240,-241,-251,-252,-1000,-255,
-1000,-1000,-257,-1000,-258,-1000,-1000,-1000,-1000,-1000,
-1000,-190,-1000,-1000,-1000,-1000,-1000,-1000,-109,-148,
-149,-1000,-171,-150,-151,-152,-204,-206,-153,-154,
-155,-156,-1000,-157,-266,-267,-1000,-1000,-258,-1000,
-1000,-1000,-1000,-258,-1000,-258,-1000,-1000,-1000,-1000,
-1000,-209,-158,-159,-160,-254,-269,-1000,-1000,-1000,
-1000,-210,-270,-211,-271,-1000 };
short yypgo[]={

   0, 195, 134, 213, 180, 212, 203, 234, 205, 211,
 210, 200, 209, 208, 207, 206, 204 };
short yyr1[]={

   0,  12,  12,  12,  13,  13,  13,  13,  13,  13,
  13,  13,  13,  13,  13,  13,  13,  13,  13,  13,
  13,  13,  13,  13,  13,  13,  13,  13,  13,  13,
  13,  13,  13,  13,  13,  13,  13,  13,  13,  13,
  13,  13,  13,  13,  13,  13,  13,  13,  13,  13,
  13,  13,  13,  13,  13,  13,  14,  14,  14,  14,
  14,  14,  14,  14,  14,  14,   4,   1,   1,   6,
  15,   8,   8,   8,  16,  16,  16,  16,  16,  16,
  16,  16,   9,   9,   9,  10,  10,  10,   2,   3,
   5,  11,   7 };
short yyr2[]={

   0,   0,   2,   2,   4,   4,   5,   3,   5,   5,
   5,   5,   9,   5,   5,   5,   3,   5,   3,   5,
   5,   3,   5,   5,   3,   3,   5,   3,   5,   3,
   5,   5,   3,   3,   5,   7,   5,   7,   9,   5,
   7,   7,   7,   5,   7,   9,   7,   9,   7,   7,
   5,   3,   5,   5,   2,   2,   5,   5,   5,   7,
   5,   5,   7,   5,   7,   5,   1,   0,   1,   1,
  11,   1,   1,   1,   1,   3,   1,   3,   1,   1,
   3,   2,   1,   1,   1,   1,   1,   1,   1,   1,
   1,   1,   0 };
short yychk[]={

-1000, -12, -13, -14, 274, 275, 279, 280, 281, 282,
 283, 294, 284, 285, 286, 302, 301, 304, 299, 297,
 298, 300, 305, 306, 307, 308, 309, 310, 303, 311,
 313, 314, 315, 278, 256, 296, 295, 269, 269,  -7,
  -7,  -7,  -7,  -7,  -7,  -7,  -7,  -7,  -7,  -7,
  -7,  -7,  -7,  -7,  -7,  -7,  -7,  -7,  -7,  -7,
  -7,  -7,  -7,  -7,  -7,  -7, 270, 270,  -7,  -7,
  -4, 272,  -1, 272, 269, 270, 269, 269, 269, 269,
 269, 269, 269, 270, 269, 270, 269, 269, 270, 269,
 269, 270, 270, 269, 270, 269, 270, 269, 269, 270,
 270, 269, 269, 270, 269, 269, 269, 269, 270, 270,
 -15, 273, -16, 257, 260, 262, 263,  -9, 261, 266,
 265, -10, 267, 258, 259, 273,  -2,  -3, 272,  -2,
  -2, 272,  -2,  -2,  -2,  -2,  -2, 272,  -2,  -2,
 305, 316, 318, 317, 319, 320, 321, 322, 323, 324,
 325, 327, 326, 328, 329,  -2,  -2,  -2,  -2,  -6,
 273, 270, 271, 270, 269, 269, 269,  -6, 270, 270,
 270, 269, 270, 270, 270, 270, 270, 270, 270, 270,
 270, 270, 270, 270, 270, 269, 270, 269, 269, 270,
 269, 269, 269, 270, 269, 269, 269, 269, 270, 269,
 270, 270, 269, 270, 269, 270, 270, 270, 270, 270,
 270, 273,  -8, 264, 268, 259,  -8,  -6, 266, 272,
 -11, 273, -11, 273,  -4,  -1, 272, 272, 272, 272,
 272,  -5, 272,  -2, 271, 269, 270, 270, 269, 270,
 270, 270, 270, 269, 270, 269, 270, 270, 270, 270,
 270, 273, 273,  -2,  -2,  -2, 271, 270, 270, 270,
 270, 273, 271, 273, 271, 273 };
short yydef[]={

   1,  -2,   2,   3,   0,   0,  92,  92,  92,  92,
  92,  92,  92,  92,  92,  92,  92,  92,  92,  92,
  92,  92,  92,  92,  92,  92,  92,  92,  92,  92,
  92,  92,  92,   0,   0,  92,  92,   0,  67,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   0,   0,   0,  54,  55,   0,   0,
   0,  66,   0,  68,   0,   7,   0,   0,   0,   0,
   0,   0,   0,  16,   0,  18,   0,   0,  21,   0,
   0,  24,  25,   0,  27,   0,  29,   0,   0,  32,
  33,   0,   0,  51,   0,   0,   0,   0,   4,   5,
   0,   0,   0,  74,  76,  78,  79,   0,  82,  83,
  84,   0,  85,  86,  87,   0,   0,  88,  89,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
  69,   6,   0,   8,   0,   0,   0,  81,   9,  10,
  11,   0,  13,  14,  15,  17,  19,  20,  22,  23,
  26,  28,  30,  31,  34,   0,  36,   0,   0,  39,
   0,   0,  67,  43,   0,   0,   0,   0,  58,   0,
  60,  61,   0,  63,   0,  65,  50,  52,  53,  56,
  57,   0,  75,  71,  72,  73,  77,  80,   0,   0,
   0,  91,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,  90,   0,   0,   0,  35,  37,   0,  40,
  41,  42,  44,   0,  46,   0,  48,  49,  59,  62,
  64,   0,   0,   0,   0,   0,   0,  12,  38,  45,
  47,   0,   0,   0,   0,  70 };
# line 1 "/usr/lib/yaccpar"
#ifndef lint
static char yaccpar_sccsid[] = "@(#)yaccpar	4.1	(Berkeley)	2/11/83";
#endif not lint

# define YYFLAG -1000
# define YYERROR goto yyerrlab
# define YYACCEPT return(0)
# define YYABORT return(1)

/*	parser for yacc output	*/

#ifdef YYDEBUG
int yydebug = 0; /* 1 for debugging */
#endif
YYSTYPE yyv[YYMAXDEPTH]; /* where the values are stored */
int yychar = -1; /* current input token number */
int yynerrs = 0;  /* number of errors */
short yyerrflag = 0;  /* error recovery flag */

yyparse() {

	short yys[YYMAXDEPTH];
	short yyj, yym;
	register YYSTYPE *yypvt;
	register short yystate, *yyps, yyn;
	register YYSTYPE *yypv;
	register short *yyxi;

	yystate = 0;
	yychar = -1;
	yynerrs = 0;
	yyerrflag = 0;
	yyps= &yys[-1];
	yypv= &yyv[-1];

 yystack:    /* put a state and value onto the stack */

#ifdef YYDEBUG
	if( yydebug  ) printf( "state %d, char 0%o\n", yystate, yychar );
#endif
		if( ++yyps>= &yys[YYMAXDEPTH] ) { yyerror( "yacc stack overflow" ); return(1); }
		*yyps = yystate;
		++yypv;
		*yypv = yyval;

 yynewstate:

	yyn = yypact[yystate];

	if( yyn<= YYFLAG ) goto yydefault; /* simple state */

	if( yychar<0 ) if( (yychar=yylex())<0 ) yychar=0;
	if( (yyn += yychar)<0 || yyn >= YYLAST ) goto yydefault;

	if( yychk[ yyn=yyact[ yyn ] ] == yychar ){ /* valid shift */
		yychar = -1;
		yyval = yylval;
		yystate = yyn;
		if( yyerrflag > 0 ) --yyerrflag;
		goto yystack;
		}

 yydefault:
	/* default state action */

	if( (yyn=yydef[yystate]) == -2 ) {
		if( yychar<0 ) if( (yychar=yylex())<0 ) yychar = 0;
		/* look through exception table */

		for( yyxi=yyexca; (*yyxi!= (-1)) || (yyxi[1]!=yystate) ; yyxi += 2 ) ; /* VOID */

		while( *(yyxi+=2) >= 0 ){
			if( *yyxi == yychar ) break;
			}
		if( (yyn = yyxi[1]) < 0 ) return(0);   /* accept */
		}

	if( yyn == 0 ){ /* error */
		/* error ... attempt to resume parsing */

		switch( yyerrflag ){

		case 0:   /* brand new error */

			yyerror( "syntax error" );
		yyerrlab:
			++yynerrs;

		case 1:
		case 2: /* incompletely recovered error ... try again */

			yyerrflag = 3;

			/* find a state where "error" is a legal shift action */

			while ( yyps >= yys ) {
			   yyn = yypact[*yyps] + YYERRCODE;
			   if( yyn>= 0 && yyn < YYLAST && yychk[yyact[yyn]] == YYERRCODE ){
			      yystate = yyact[yyn];  /* simulate a shift of "error" */
			      goto yystack;
			      }
			   yyn = yypact[*yyps];

			   /* the current yyps has no shift onn "error", pop stack */

#ifdef YYDEBUG
			   if( yydebug ) printf( "error recovery pops state %d, uncovers %d\n", *yyps, yyps[-1] );
#endif
			   --yyps;
			   --yypv;
			   }

			/* there is no state on the stack with an error shift ... abort */

	yyabort:
			return(1);


		case 3:  /* no shift yet; clobber input char */

#ifdef YYDEBUG
			if( yydebug ) printf( "error recovery discards char %d\n", yychar );
#endif

			if( yychar == 0 ) goto yyabort; /* don't discard EOF, quit */
			yychar = -1;
			goto yynewstate;   /* try again in the same state */

			}

		}

	/* reduction by production yyn */

#ifdef YYDEBUG
		if( yydebug ) printf("reduce %d\n",yyn);
#endif
		yyps -= yyr2[yyn];
		yypvt = yypv;
		yypv -= yyr2[yyn];
		yyval = yypv[1];
		yym=yyn;
			/* consult goto table to find next state */
		yyn = yyr1[yyn];
		yyj = yypgo[yyn] + *yyps + 1;
		if( yyj>=YYLAST || yychk[ yystate = yyact[yyj] ] != -yyn ) yystate = yyact[yypgo[yyn]];
		switch(yym){
			
case 2:
# line 197 "ftpcmd.y"
	{
	    fromname = (char *) NULL;
	    restart_point = 0;
	} break;
case 4:
# line 205 "ftpcmd.y"
	{
	    user(yypvt[-1].String);
	    if (log_commands)
		syslog(LOG_INFO, "USER %s", yypvt[-1].String);
	    free(yypvt[-1].String);
	} break;
case 5:
# line 212 "ftpcmd.y"
	{
	    if (log_commands)
		if (anonymous)
		    syslog(LOG_INFO, "PASS %s", yypvt[-1].String);
		else
		    syslog(LOG_INFO, "PASS password");

	    pass(yypvt[-1].String);
	    free(yypvt[-1].String);
	} break;
case 6:
# line 223 "ftpcmd.y"
	{
	    if (log_commands)
		syslog(LOG_INFO, "PORT");
/* H* port fix, part B: admonish the twit.
   Also require login before PORT works */
	    if (yypvt[-3].Number) {
#ifndef DISABLE_PORT
		if (((cliaddr.s_addr == his_addr.sin_addr.s_addr)
		     || (port_allowed(inet_ntoa(cliaddr))))
		    && (ntohs(cliport) > 1023)) {
		    usedefault = 0;
		    if (pdata >= 0) {
			(void) close(pdata);
			pdata = -1;
		    }
		    data_dest.sin_family = AF_INET;
		    data_dest.sin_addr = cliaddr;
		    data_dest.sin_port = cliport;
		    reply(200, "PORT command successful.");
		}
		else {
#endif
		    memset(&data_dest, 0, sizeof(data_dest));
		    syslog(LOG_WARNING, "refused PORT %s,%d from %s",
			   inet_ntoa(cliaddr), ntohs(cliport), remoteident);
		    reply(500, "Illegal PORT Command");
#ifndef DISABLE_PORT
		}
#endif
	    }
	} break;
case 7:
# line 255 "ftpcmd.y"
	{
/* Require login for PASV, too.  This actually fixes a bug -- telnet to an
   unfixed wu-ftpd and type PASV first off, and it crashes! */
	    if (log_commands)
		syslog(LOG_INFO, "PASV");
	    if (yypvt[-1].Number)
#if (defined (DISABLE_PORT) || !defined (DISABLE_PASV))
		passive();
#else
		reply(425, "Cannot open passive connection");
#endif
	} break;
case 8:
# line 268 "ftpcmd.y"
	{
	    if (log_commands)
		syslog(LOG_INFO, "TYPE %s", typenames[cmd_type]);
	    if (yypvt[-3].Number)
		switch (cmd_type) {

		case TYPE_A:
		    if (cmd_form == FORM_N) {
			reply(200, "Type set to A.");
			type = cmd_type;
			form = cmd_form;
		    }
		    else
			reply(504, "Form must be N.");
		    break;

		case TYPE_E:
		    reply(504, "Type E not implemented.");
		    break;

		case TYPE_I:
		    reply(200, "Type set to I.");
		    type = cmd_type;
		    break;

		case TYPE_L:
#if NBBY == 8
		    if (cmd_bytesz == 8) {
			reply(200,
			      "Type set to L (byte size 8).");
			type = cmd_type;
		    }
		    else
			reply(504, "Byte size must be 8.");
#else /* NBBY == 8 */
#error UNIMPLEMENTED for NBBY != 8
#endif /* NBBY == 8 */
		}
	} break;
case 9:
# line 308 "ftpcmd.y"
	{
	    if (log_commands)
		syslog(LOG_INFO, "STRU %s", strunames[yypvt[-1].Number]);
	    if (yypvt[-3].Number)
		switch (yypvt[-1].Number) {

		case STRU_F:
		    reply(200, "STRU F ok.");
		    break;

		default:
		    reply(504, "Unimplemented STRU type.");
		}
	} break;
case 10:
# line 323 "ftpcmd.y"
	{
	    if (log_commands)
		syslog(LOG_INFO, "MODE %s", modenames[yypvt[-1].Number]);
	    if (yypvt[-3].Number)
		switch (yypvt[-1].Number) {

		case MODE_S:
		    reply(200, "MODE S ok.");
		    break;

		default:
		    reply(502, "Unimplemented MODE type.");
		}
	} break;
case 11:
# line 338 "ftpcmd.y"
	{
	    if (log_commands)
		syslog(LOG_INFO, "ALLO %d", yypvt[-1].Number);
	    if (yypvt[-3].Number)
		reply(202, "ALLO command ignored.");
	} break;
case 12:
# line 345 "ftpcmd.y"
	{
	    if (log_commands)
		syslog(LOG_INFO, "ALLO %d R %d", yypvt[-5].Number, yypvt[-1].Number);
	    if (yypvt[-7].Number)
		reply(202, "ALLO command ignored.");
	} break;
case 13:
# line 352 "ftpcmd.y"
	{
	    if (log_commands)
		syslog(LOG_INFO, "RETR %s", CHECKNULL(yypvt[-1].String));
	    if (yypvt[-3].Number && yypvt[-1].String != NULL && !restrict_check(yypvt[-1].String)) {
		retrieve_is_data = 1;
		retrieve((char *) NULL, yypvt[-1].String);
	    }
	    if (yypvt[-1].String != NULL)
		free(yypvt[-1].String);
	} break;
case 14:
# line 363 "ftpcmd.y"
	{
	    if (log_commands)
		syslog(LOG_INFO, "STOR %s", CHECKNULL(yypvt[-1].String));
	    if (yypvt[-3].Number && yypvt[-1].String != NULL && !restrict_check(yypvt[-1].String))
		store(yypvt[-1].String, "w", 0);
	    if (yypvt[-1].String != NULL)
		free(yypvt[-1].String);
	} break;
case 15:
# line 372 "ftpcmd.y"
	{
	    if (log_commands)
		syslog(LOG_INFO, "APPE %s", CHECKNULL(yypvt[-1].String));
	    if (yypvt[-3].Number && yypvt[-1].String != NULL && !restrict_check(yypvt[-1].String))
		store(yypvt[-1].String, "a", 0);
	    if (yypvt[-1].String != NULL)
		free(yypvt[-1].String);
	} break;
case 16:
# line 381 "ftpcmd.y"
	{
	    if (log_commands)
		syslog(LOG_INFO, "NLST");
	    if (yypvt[-1].Number && !restrict_check("."))
		send_file_list("");
	} break;
case 17:
# line 388 "ftpcmd.y"
	{
	    if (log_commands)
		syslog(LOG_INFO, "NLST %s", yypvt[-1].String);
	    if (yypvt[-3].Number && yypvt[-1].String && !restrict_check(yypvt[-1].String))
		send_file_list(yypvt[-1].String);
	    if (yypvt[-1].String != NULL)
		free(yypvt[-1].String);
	} break;
case 18:
# line 397 "ftpcmd.y"
	{
	    if (log_commands)
		syslog(LOG_INFO, "LIST");
	    if (yypvt[-1].Number && !restrict_check(".")) {
		retrieve_is_data = 0;
#ifndef INTERNAL_LS
		if (anonymous && dolreplies)
		    retrieve(ls_long, "");
		else
		    retrieve(ls_short, "");
#else
		ls(NULL, 0);
#endif
	    }
	} break;
case 19:
# line 413 "ftpcmd.y"
	{
	    if (log_commands)
		syslog(LOG_INFO, "LIST %s", CHECKNULL(yypvt[-1].String));
	    if (yypvt[-3].Number && yypvt[-1].String != NULL && !restrict_list_check(yypvt[-1].String)) {
		retrieve_is_data = 0;
#ifndef INTERNAL_LS
		if (anonymous && dolreplies)
		    retrieve(ls_long, yypvt[-1].String);
		else
		    retrieve(ls_short, yypvt[-1].String);
#else
		ls(yypvt[-1].String, 0);
#endif
	    }
	    if (yypvt[-1].String != NULL)
		free(yypvt[-1].String);
	} break;
case 20:
# line 431 "ftpcmd.y"
	{
	    if (log_commands)
		syslog(LOG_INFO, "STAT %s", CHECKNULL(yypvt[-1].String));
	    if (yypvt[-3].Number && yypvt[-1].String != NULL && !restrict_check(yypvt[-1].String))
		statfilecmd(yypvt[-1].String);
	    if (yypvt[-1].String != NULL)
		free(yypvt[-1].String);
	} break;
case 21:
# line 440 "ftpcmd.y"
	{
	    if (log_commands)
		syslog(LOG_INFO, "STAT");
	    if (yypvt[-1].Number)
		statcmd();
	} break;
case 22:
# line 447 "ftpcmd.y"
	{
	    if (log_commands)
		syslog(LOG_INFO, "DELE %s", CHECKNULL(yypvt[-1].String));
	    if (yypvt[-3].Number && yypvt[-1].String != NULL && !restrict_check(yypvt[-1].String))
		delete(yypvt[-1].String);
	    if (yypvt[-1].String != NULL)
		free(yypvt[-1].String);
	} break;
case 23:
# line 456 "ftpcmd.y"
	{
	    if (log_commands)
		syslog(LOG_INFO, "RNTO %s", CHECKNULL(yypvt[-1].String));
	    if (yypvt[-3].Number && yypvt[-1].String && !restrict_check(yypvt[-1].String)) {
		if (fromname) {
		    renamecmd(fromname, yypvt[-1].String);
		    free(fromname);
		    fromname = (char *) NULL;
		}
		else {
		    reply(503, "Bad sequence of commands.");
		}
	    }
	    if (yypvt[-1].String)
		free(yypvt[-1].String);
	} break;
case 24:
# line 473 "ftpcmd.y"
	{
	    if (log_commands)
		syslog(LOG_INFO, "ABOR");
	    if (yypvt[-1].Number)
		reply(225, "ABOR command successful.");
	} break;
case 25:
# line 480 "ftpcmd.y"
	{
	    if (log_commands)
		syslog(LOG_INFO, "CWD");
	    if (yypvt[-1].Number && !restrict_check(home))
		cwd(home);
	} break;
case 26:
# line 487 "ftpcmd.y"
	{
	    if (log_commands)
		syslog(LOG_INFO, "CWD %s", CHECKNULL(yypvt[-1].String));
	    if (yypvt[-3].Number && yypvt[-1].String != NULL && !restrict_check(yypvt[-1].String))
		cwd(yypvt[-1].String);
	    if (yypvt[-1].String != NULL)
		free(yypvt[-1].String);
	} break;
case 27:
# line 496 "ftpcmd.y"
	{
	    if (log_commands)
		syslog(LOG_INFO, "HELP");
	    if (yypvt[-1].Number)
		help(cmdtab, (char *) NULL);
	} break;
case 28:
# line 503 "ftpcmd.y"
	{
	    register char *cp = (char *) yypvt[-1].String;

	    if (log_commands)
		syslog(LOG_INFO, "HELP %s", yypvt[-1].String);
	    if (yypvt[-3].Number)
		if (strncasecmp(cp, "SITE", 4) == 0) {
		    cp = (char *) yypvt[-1].String + 4;
		    if (*cp == ' ')
			cp++;
		    if (*cp)
			help(sitetab, cp);
		    else
			help(sitetab, (char *) NULL);
		}
		else
		    help(cmdtab, yypvt[-1].String);
	    if (yypvt[-1].String != NULL)
		free(yypvt[-1].String);
	} break;
case 29:
# line 524 "ftpcmd.y"
	{
	    if (log_commands)
		syslog(LOG_INFO, "NOOP");
	    if (yypvt[-1].Number)
		reply(200, "NOOP command successful.");
	} break;
case 30:
# line 531 "ftpcmd.y"
	{
	    if (log_commands)
		syslog(LOG_INFO, "MKD %s", CHECKNULL(yypvt[-1].String));
	    if (yypvt[-3].Number && yypvt[-1].String != NULL && !restrict_check(yypvt[-1].String))
		makedir(yypvt[-1].String);
	    if (yypvt[-1].String != NULL)
		free(yypvt[-1].String);
	} break;
case 31:
# line 540 "ftpcmd.y"
	{
	    if (log_commands)
		syslog(LOG_INFO, "RMD %s", CHECKNULL(yypvt[-1].String));
	    if (yypvt[-3].Number && yypvt[-1].String != NULL && !restrict_check(yypvt[-1].String))
		removedir(yypvt[-1].String);
	    if (yypvt[-1].String != NULL)
		free(yypvt[-1].String);
	} break;
case 32:
# line 549 "ftpcmd.y"
	{
	    if (log_commands)
		syslog(LOG_INFO, "PWD");
	    if (yypvt[-1].Number)
		pwd();
	} break;
case 33:
# line 556 "ftpcmd.y"
	{
	    if (log_commands)
		syslog(LOG_INFO, "CDUP");
	    if (yypvt[-1].Number)
		if (!test_restriction(".."))
		    cwd("..");
		else
		    ack("CWD");
	} break;
case 34:
# line 567 "ftpcmd.y"
	{
	    if (log_commands)
		syslog(LOG_INFO, "SITE HELP");
	    if (yypvt[-3].Number)
		help(sitetab, (char *) NULL);
	} break;
case 35:
# line 574 "ftpcmd.y"
	{
	    if (log_commands)
		syslog(LOG_INFO, "SITE HELP %s", yypvt[-1].String);
	    if (yypvt[-5].Number)
		help(sitetab, yypvt[-1].String);
	    if (yypvt[-1].String != NULL)
		free(yypvt[-1].String);
	} break;
case 36:
# line 583 "ftpcmd.y"
	{
	    mode_t oldmask;

	    if (log_commands)
		syslog(LOG_INFO, "SITE UMASK");
	    if (yypvt[-3].Number) {
		oldmask = umask(0);
		(void) umask(oldmask);
		reply(200, "Current UMASK is %03o", oldmask);
	    }
	} break;
case 37:
# line 595 "ftpcmd.y"
	{
	    mode_t oldmask;
	    struct aclmember *entry = NULL;
	    int ok = 1;

	    if (log_commands)
		syslog(LOG_INFO, "SITE UMASK %03o", yypvt[-1].Number);
	    if (yypvt[-5].Number) {
		/* check for umask permission */
		while (getaclentry("umask", &entry) && ARG0 && ARG1 != NULL) {
		    if (type_match(ARG1))
			if (*ARG0 == 'n')
			    ok = 0;
		}
		if (ok && !restricted_user) {
		    if ((yypvt[-1].Number < 0) || (yypvt[-1].Number > 0777)) {
			reply(501, "Bad UMASK value");
		    }
		    else {
			oldmask = umask((mode_t) yypvt[-1].Number);
			reply(200, "UMASK set to %03o (was %03o)", yypvt[-1].Number, oldmask);
		    }
		}
		else
		    reply(553, "Permission denied on server. (umask)");
	    }
	} break;
case 38:
# line 623 "ftpcmd.y"
	{
	    struct aclmember *entry = NULL;
	    int ok = (anonymous ? 0 : 1);

	    if (log_commands)
		syslog(LOG_INFO, "SITE CHMOD %03o %s", yypvt[-3].Number, CHECKNULL(yypvt[-1].String));
	    if (yypvt[-7].Number && yypvt[-1].String) {
		/* check for chmod permission */
		while (getaclentry("chmod", &entry) && ARG0 && ARG1 != NULL) {
		    if (type_match(ARG1))
			if (anonymous) {
			    if (*ARG0 == 'y')
				ok = 1;
			}
			else if (*ARG0 == 'n')
			    ok = 0;
		}
		if (ok) {
#ifdef UNRESTRICTED_CHMOD
		    if (chmod(yypvt[-1].String, (mode_t) yypvt[-3].Number) < 0)
#else
		    if ((yypvt[-3].Number < 0) || (yypvt[-3].Number > 0777))
			reply(501,
			    "CHMOD: Mode value must be between 0 and 0777");
		    else if (chmod(yypvt[-1].String, (mode_t) yypvt[-3].Number) < 0)
#endif
			perror_reply(550, yypvt[-1].String);
		    else {
			char path[MAXPATHLEN];

			wu_realpath(yypvt[-1].String, path, chroot_path);

			if (log_security)
			    if (anonymous) {
				syslog(LOG_NOTICE, "%s of %s changed permissions for %s", guestpw, remoteident, path);
			    }
			    else {
				syslog(LOG_NOTICE, "%s of %s changed permissions for %s", pw->pw_name,
				       remoteident, path);
			    }
			reply(200, "CHMOD command successful.");
		    }
		}
		else
		    reply(553, "Permission denied on server. (chmod)");
	    }
	    if (yypvt[-1].String != NULL)
		free(yypvt[-1].String);
	} break;
case 39:
# line 673 "ftpcmd.y"
	{
	    if (log_commands)
		syslog(LOG_INFO, "SITE IDLE");
	    if (yypvt[-3].Number)
		reply(200,
		      "Current IDLE time limit is %d seconds; max %d",
		      timeout_idle, timeout_maxidle);
	} break;
case 40:
# line 682 "ftpcmd.y"
	{
	    if (log_commands)
		syslog(LOG_INFO, "SITE IDLE %d", yypvt[-1].Number);
	    if (yypvt[-5].Number)
		if (yypvt[-1].Number < 30 || yypvt[-1].Number > timeout_maxidle) {
		    reply(501,
		      "Maximum IDLE time must be between 30 and %d seconds",
			  timeout_maxidle);
		}
		else {
		    timeout_idle = yypvt[-1].Number;
		    reply(200, "Maximum IDLE time set to %d seconds", timeout_idle);
		}
	} break;
case 41:
# line 697 "ftpcmd.y"
	{
#ifndef NO_PRIVATE
	    if (log_commands)
		syslog(LOG_INFO, "SITE GROUP %s", yypvt[-1].String);
	    if (!restricted_user && yypvt[-5].Number && yypvt[-1].String)
		priv_group(yypvt[-1].String);
	    free(yypvt[-1].String);
#endif /* !NO_PRIVATE */
	} break;
case 42:
# line 707 "ftpcmd.y"
	{
#ifndef NO_PRIVATE
	    if (log_commands)
		syslog(LOG_INFO, "SITE GPASS password");
	    if (!restricted_user && yypvt[-5].Number && yypvt[-1].String)
		priv_gpass(yypvt[-1].String);
	    free(yypvt[-1].String);
#endif /* !NO_PRIVATE */
	} break;
case 43:
# line 717 "ftpcmd.y"
	{
#ifndef NO_PRIVATE
	    if (log_commands)
		syslog(LOG_INFO, "SITE GPASS");
	    if (!restricted_user && yypvt[-3].Number)
		priv_gpass(NULL);
#endif /* !NO_PRIVATE */
	} break;
case 44:
# line 726 "ftpcmd.y"
	{
	    if (log_commands)
		syslog(LOG_INFO, "SITE NEWER %s", yypvt[-1].String);
#ifdef SITE_NEWER
	    if (yypvt[-5].Number && yypvt[-1].String && !restrict_check("."))
		newer(yypvt[-1].String, ".", 0);
#else
	    reply(500, "Command no longer honored by this server");
#endif
	    free(yypvt[-1].String);
	} break;
case 45:
# line 738 "ftpcmd.y"
	{
	    if (log_commands)
		syslog(LOG_INFO, "SITE NEWER %s %s", yypvt[-3].String,
		       CHECKNULL(yypvt[-1].String));
#ifdef SITE_NEWER
	    if (yypvt[-7].Number && yypvt[-3].String && yypvt[-1].String && !restrict_check(yypvt[-1].String))
		newer(yypvt[-3].String, yypvt[-1].String, 0);
#else
	    reply(500, "Command no longer honored by this server");
#endif
	    free(yypvt[-3].String);
	    if (yypvt[-1].String)
		free(yypvt[-1].String);
	} break;
case 46:
# line 753 "ftpcmd.y"
	{
	    if (log_commands)
		syslog(LOG_INFO, "SITE MINFO %s", yypvt[-1].String);
#ifdef SITE_NEWER
	    if (yypvt[-5].Number && yypvt[-1].String && !restrict_check("."))
		newer(yypvt[-1].String, ".", 1);
#else
	    reply(500, "Command no longer honored by this server");
#endif
	    free(yypvt[-1].String);
	} break;
case 47:
# line 765 "ftpcmd.y"
	{
	    if (log_commands)
		syslog(LOG_INFO, "SITE MINFO %s %s", yypvt[-3].String,
		       CHECKNULL(yypvt[-1].String));
#ifdef SITE_NEWER
	    if (yypvt[-7].Number && yypvt[-3].String && yypvt[-1].String && !restrict_check(yypvt[-1].String))
		newer(yypvt[-3].String, yypvt[-1].String, 1);
#else
	    reply(500, "Command no longer honored by this server");
#endif
	    free(yypvt[-3].String);
	    if (yypvt[-1].String)
		free(yypvt[-1].String);
	} break;
case 48:
# line 780 "ftpcmd.y"
	{
	    /* this is just for backward compatibility since we
	     * thought of INDEX before we thought of EXEC
	     */
	    if (!restricted_user && yypvt[-5].Number != 0 && yypvt[-1].String != NULL) {
		char buf[MAXPATHLEN];
		if (strlen(yypvt[-1].String) + 7 <= sizeof(buf)) {
		    sprintf(buf, "index %s", (char *) yypvt[-1].String);
		    (void) site_exec(buf);
		}
	    }
	    if (yypvt[-1].String != NULL)
		free(yypvt[-1].String);
	} break;
case 49:
# line 795 "ftpcmd.y"
	{
	    if (!restricted_user && yypvt[-5].Number != 0 && yypvt[-1].String != NULL) {
		(void) site_exec((char *) yypvt[-1].String);
	    }
	    if (yypvt[-1].String != NULL)
		free(yypvt[-1].String);
	} break;
case 50:
# line 804 "ftpcmd.y"
	{
	    if (log_commands)
		syslog(LOG_INFO, "STOU %s", CHECKNULL(yypvt[-1].String));
	    if (yypvt[-3].Number && yypvt[-1].String && !restrict_check(yypvt[-1].String))
		store(yypvt[-1].String, "w", 1);
	    if (yypvt[-1].String != NULL)
		free(yypvt[-1].String);
	} break;
case 51:
# line 813 "ftpcmd.y"
	{
	    if (log_commands)
		syslog(LOG_INFO, "SYST");
	    if (yypvt[-1].Number)
#ifdef BSD
		reply(215, "UNIX Type: L%d Version: BSD-%d",
		      NBBY, BSD);
#else /* BSD */
#if defined (unix) || defined (__unix__)
		reply(215, "UNIX Type: L%d", NBBY);
#else /* unix */
		reply(215, "UNKNOWN Type: L%d", NBBY);
#endif /* unix */
#endif /* BSD */
	} break;
case 52:
# line 837 "ftpcmd.y"
	{
	    if (log_commands)
		syslog(LOG_INFO, "SIZE %s", CHECKNULL(yypvt[-1].String));
	    if (yypvt[-3].Number && yypvt[-1].String && !restrict_check(yypvt[-1].String)) {
		sizecmd(yypvt[-1].String);
	    }
	    if (yypvt[-1].String != NULL)
		free(yypvt[-1].String);
	} break;
case 53:
# line 857 "ftpcmd.y"
	{
	    if (log_commands)
		syslog(LOG_INFO, "MDTM %s", CHECKNULL(yypvt[-1].String));
	    if (yypvt[-3].Number && yypvt[-1].String && !restrict_check(yypvt[-1].String)) {
		struct stat stbuf;

		if (stat(yypvt[-1].String, &stbuf) < 0)
		    perror_reply(550, yypvt[-1].String);
		else if ((stbuf.st_mode & S_IFMT) != S_IFREG) {
		    reply(550, "%s: not a plain file.",
			  yypvt[-1].String);
		}
		else {
		    register struct tm *t;
		    t = gmtime(&stbuf.st_mtime);
		    reply(213,
			  "%04d%02d%02d%02d%02d%02d",
			  t->tm_year + 1900, t->tm_mon + 1, t->tm_mday,
			  t->tm_hour, t->tm_min, t->tm_sec);
		}
	    }
	    if (yypvt[-1].String != NULL)
		free(yypvt[-1].String);
	} break;
case 54:
# line 882 "ftpcmd.y"
	{
	    if (log_commands)
		syslog(LOG_INFO, "QUIT");
#ifdef TRANSFER_COUNT
	    if (logged_in) {
		lreply(221, "You have transferred %d bytes in %d files.", data_count_total, file_count_total);
		lreply(221, "Total traffic for this session was %d bytes in %d transfers.", byte_count_total, xfer_count_total);
		lreply(221, "Thank you for using the FTP service on %s.", hostname);
	    }
#endif /* TRANSFER_COUNT */
	    reply(221, "Goodbye.");
	    dologout(0);
	} break;
case 55:
# line 896 "ftpcmd.y"
	{
	    yyerrok;
	} break;
case 56:
# line 902 "ftpcmd.y"
	{

	    if (log_commands)
		syslog(LOG_INFO, "RNFR %s", CHECKNULL(yypvt[-1].String));
	    if (yypvt[-3].Number)
		restart_point = (off_t) 0;
	    if (yypvt[-3].Number && yypvt[-1].String && !restrict_check(yypvt[-1].String)) {
		fromname = renamefrom(yypvt[-1].String);
	    }
	    if (fromname == 0 && yypvt[-1].String)
		free(yypvt[-1].String);
	} break;
case 57:
# line 915 "ftpcmd.y"
	{
	    if (log_commands)
		syslog(LOG_INFO, "REST %d", (int) restart_point);
	    if (yypvt[-3].Number) {
		fromname = 0;
		restart_point = yypvt[-1].Number;
		reply(350, "Restarting at %ld. %s", (long) restart_point,
		      "Send STORE or RETRIEVE to initiate transfer.");
	    }
	} break;
case 58:
# line 927 "ftpcmd.y"
	{
	    if (log_commands)
		syslog(LOG_INFO, "SITE ALIAS");
	    if (yypvt[-3].Number)
		alias((char *) NULL);
	} break;
case 59:
# line 934 "ftpcmd.y"
	{
	    if (log_commands)
		syslog(LOG_INFO, "SITE ALIAS %s", yypvt[-1].String);
	    if (yypvt[-5].Number)
		alias(yypvt[-1].String);
	    if (yypvt[-1].String != NULL)
		free(yypvt[-1].String);
	} break;
case 60:
# line 943 "ftpcmd.y"
	{
	    if (log_commands)
		syslog(LOG_INFO, "SITE GROUPS");
	    if (yypvt[-3].Number)
		print_groups();
	} break;
case 61:
# line 950 "ftpcmd.y"
	{
	    if (log_commands)
		syslog(LOG_INFO, "SITE CDPATH");
	    if (yypvt[-3].Number)
		cdpath();
	} break;
case 62:
# line 957 "ftpcmd.y"
	{
	    if (log_commands)
		syslog(LOG_INFO, "SITE CHECKMETHOD %s", CHECKNULL(yypvt[-1].String));
	    if ((yypvt[-5].Number) && (yypvt[-1].String != NULL))
		SetCheckMethod(yypvt[-1].String);
	    if (yypvt[-1].String != NULL)
		free(yypvt[-1].String);
	} break;
case 63:
# line 966 "ftpcmd.y"
	{
	    if (log_commands)
		syslog(LOG_INFO, "SITE CHECKMETHOD");
	    if (yypvt[-3].Number)
		ShowCheckMethod();
	} break;
case 64:
# line 973 "ftpcmd.y"
	{
	    if (log_commands)
		syslog(LOG_INFO, "SITE CHECKSUM %s", CHECKNULL(yypvt[-1].String));
	    if ((yypvt[-5].Number) && (yypvt[-1].String != NULL) && (!restrict_check(yypvt[-1].String)))
		CheckSum(yypvt[-1].String);
	    if (yypvt[-1].String != NULL)
		free(yypvt[-1].String);
	} break;
case 65:
# line 982 "ftpcmd.y"
	{
	    if (log_commands)
		syslog(LOG_INFO, "SITE CHECKSUM");
	    if (yypvt[-3].Number)
		CheckSumLastFile();
	} break;
case 67:
# line 994 "ftpcmd.y"
	{
	    yyval.String = (char *) malloc(1);
	    yyval.String[0] = '\0';
	} break;
case 70:
# line 1005 "ftpcmd.y"
	{
	    register char *a, *p;

	    a = (char *) &cliaddr;
	    a[0] = yypvt[-10].Number;
	    a[1] = yypvt[-8].Number;
	    a[2] = yypvt[-6].Number;
	    a[3] = yypvt[-4].Number;
	    p = (char *) &cliport;
	    p[0] = yypvt[-2].Number;
	    p[1] = yypvt[-0].Number;
	} break;
case 71:
# line 1020 "ftpcmd.y"
	{
	    yyval.Number = FORM_N;
	} break;
case 72:
# line 1024 "ftpcmd.y"
	{
	    yyval.Number = FORM_T;
	} break;
case 73:
# line 1028 "ftpcmd.y"
	{
	    yyval.Number = FORM_C;
	} break;
case 74:
# line 1034 "ftpcmd.y"
	{
	    cmd_type = TYPE_A;
	    cmd_form = FORM_N;
	} break;
case 75:
# line 1039 "ftpcmd.y"
	{
	    cmd_type = TYPE_A;
	    cmd_form = yypvt[-0].Number;
	} break;
case 76:
# line 1044 "ftpcmd.y"
	{
	    cmd_type = TYPE_E;
	    cmd_form = FORM_N;
	} break;
case 77:
# line 1049 "ftpcmd.y"
	{
	    cmd_type = TYPE_E;
	    cmd_form = yypvt[-0].Number;
	} break;
case 78:
# line 1054 "ftpcmd.y"
	{
	    cmd_type = TYPE_I;
	} break;
case 79:
# line 1058 "ftpcmd.y"
	{
	    cmd_type = TYPE_L;
	    cmd_bytesz = NBBY;
	} break;
case 80:
# line 1063 "ftpcmd.y"
	{
	    cmd_type = TYPE_L;
	    cmd_bytesz = yypvt[-0].Number;
	} break;
case 81:
# line 1069 "ftpcmd.y"
	{
	    cmd_type = TYPE_L;
	    cmd_bytesz = yypvt[-0].Number;
	} break;
case 82:
# line 1076 "ftpcmd.y"
	{
	    yyval.Number = STRU_F;
	} break;
case 83:
# line 1080 "ftpcmd.y"
	{
	    yyval.Number = STRU_R;
	} break;
case 84:
# line 1084 "ftpcmd.y"
	{
	    yyval.Number = STRU_P;
	} break;
case 85:
# line 1090 "ftpcmd.y"
	{
	    yyval.Number = MODE_S;
	} break;
case 86:
# line 1094 "ftpcmd.y"
	{
	    yyval.Number = MODE_B;
	} break;
case 87:
# line 1098 "ftpcmd.y"
	{
	    yyval.Number = MODE_C;
	} break;
case 88:
# line 1104 "ftpcmd.y"
	{
	    /*
	     * Problem: this production is used for all pathname
	     * processing, but only gives a 550 error reply.
	     * This is a valid reply in some cases but not in others.
	     */
	    if (restricted_user && logged_in && yypvt[-0].String && strncmp(yypvt[-0].String, "/", 1) == 0) {
		/*
		 * This remaps the root so it is appearently at the user's home
		 * rather than the real root/chroot.
		 */
		char **globlist;
		char *t = calloc(1 + strlen(yypvt[-0].String) + 1, sizeof(char));
		if (t == NULL) {
		    errno = EAGAIN;
		    perror_reply(550, yypvt[-0].String);
		    yyval.String = NULL;
		}
		else {
		    t[0] = '~';
		    t[1] = '\0';
		    if (strncmp(yypvt[-0].String, "/../", 4) == 0)
			strcpy(t + 1, yypvt[-0].String + 3);
		    else if (strcmp(yypvt[-0].String, "/..") != 0)
			strcpy(t + 1, yypvt[-0].String);
		    globlist = ftpglob(t);
		    if (globerr) {
			reply(550, "%s", globerr);
			yyval.String = NULL;
			if (globlist) {
			    blkfree(globlist);
			    free((char *) globlist);
			}
		    }
		    else if (globlist && *globlist) {
			yyval.String = *globlist;
			blkfree(&globlist[1]);
			free((char *) globlist);
		    }
		    else {
			if (globlist) {
			    blkfree(globlist);
			    free((char *) globlist);
			}
			errno = ENOENT;
			perror_reply(550, yypvt[-0].String);
			yyval.String = NULL;
		    }
		    free(t);
		}
		free(yypvt[-0].String);
	    }
	    else if (logged_in && yypvt[-0].String && strncmp(yypvt[-0].String, "~", 1) == 0) {
		char **globlist;

		globlist = ftpglob(yypvt[-0].String);
		if (globerr) {
		    reply(550, "%s", globerr);
		    yyval.String = NULL;
		    if (globlist) {
			blkfree(globlist);
			free((char *) globlist);
		    }
		}
		else if (globlist && *globlist) {
		    yyval.String = *globlist;
		    blkfree(&globlist[1]);
		    free((char *) globlist);
		}
		else {
		    if (globlist) {
			blkfree(globlist);
			free((char *) globlist);
		    }
		    errno = ENOENT;
		    perror_reply(550, yypvt[-0].String);
		    yyval.String = NULL;
		}
		free(yypvt[-0].String);
	    }
	    else
		yyval.String = yypvt[-0].String;
	} break;
case 91:
# line 1196 "ftpcmd.y"
	{
	    register int ret, dec, multby, digit;

	    /*
	     * Convert a number that was read as decimal number
	     * to what it would be if it had been read as octal.
	     */
	    dec = yypvt[-0].Number;
	    multby = 1;
	    ret = 0;
	    while (dec) {
		digit = dec % 10;
		if (digit > 7) {
		    ret = -1;
		    break;
		}
		ret += digit * multby;
		multby *= 8;
		dec /= 10;
	    }
	    yyval.Number = ret;
	} break;
case 92:
# line 1221 "ftpcmd.y"
	{
	    if (logged_in)
		yyval.Number = 1;
	    else {
		if (log_commands)
		    syslog(LOG_INFO, "cmd failure - not logged in");
		reply(530, "Please login with USER and PASS.");
		yyval.Number = 0;
		yyerrorcalled = 1;
	    }
	} break;
# line 148 "/usr/lib/yaccpar"

		}
		goto yystack;  /* stack new state and value */

	}
